---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Friends","LEFT")
local btn = gb.Friends
btn.text			  = "Friends"
btn.enabled		   = true
btn.events			= {"BN_FRIEND_ACCOUNT_OFFLINE","BN_FRIEND_ACCOUNT_ONLINE","FRIENDLIST_UPDATE"}
btn.update			= true
btn.tooltip		   = true
btn.click			 = true

---------------------------
-- update
---------------------------
function gf.Friends.update()
	local btn = gb.Friends
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Friends")
		local HEX = ga.colors.HEX
		local _,WoWFriends = GetNumFriends()
		local _,RealFriends = BNGetNumFriends()
		local friends = "Friends: "..HEX.green..WoWFriends..","..RealFriends
		btn.button:SetText(friends)
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Friends.tooltip()
	Glance.Debug("function","tooltip","Friends")
	local tooltip = gf.Tooltip
	local HEX = ga.colors.CLASS
	local _,WoWFriends = GetNumFriends()
	local _,RealFriends = BNGetNumFriends()
	tooltip.Line(WoWFriends.." Friend(s) Online","GLD")
	for i = 0, GetNumFriends() do
		local name, level, class, area, connected, status, note = GetFriendInfo(i)
		if connected then
			local cls = string.upper(class)
			tooltip.Double(HEX[cls]..name.." ("..level.." "..class..")", area, "WHT", "WHT")
		end
	end
	tooltip.Space()
	tooltip.Line(RealFriends.." BattleNet Friend(s) Online","GLD")
	for j = 1, BNGetNumFriends() do
		local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfo(j)
		local hasFocus, toonName, client, realmName, realmID, faction, race, class, guild, zoneName, level, gameText, broadcastText, broadcastTime = BNGetToonInfo(presenceID)
		local msg1, msg2 = "", ""
		if isOnline then
			local cls = string.upper(class)
			if (cls ~= nil and cls ~= "" and string.upper(client) == "WOW") then
				msg1 = "|cff6ff0ee"..gf.ts(presenceName).." |cff00ff00["..gf.ts(client).." - "..gf.ts(realmName).."]"
				msg2 = HEX[cls]..gf.ts(toonName).." |r("..ga.colors.HEX["green"]..gf.ts(level).." |r"..gf.ts(race).." "..HEX[cls]..gf.ts(class)..") |r"..gf.ts(zoneName)
			else
				msg1 = "|cff6ff0ee"..gf.ts(presenceName).." |cffff0000["..gf.ts(client).."]"
				msg2 = gf.ts(toonName).." "..gf.ts(gameText)
			end
			tooltip.Double(msg1, msg2, "WHT", "WHT")
		end
	end
	tooltip.Space()
	tooltip.Line("(Click to open the Friends tab.)","WHT")
end

---------------------------
-- click
---------------------------
function gf.Friends.click(self, button, down)
	Glance.Debug("function","click","Friends")
	if button == "LeftButton" then
		ToggleFriendsFrame() --removed the value "1" from being passed to fix bug.
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Friends")
end